datablock ParticleData(FMFlameMuzzleParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.1;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 200.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.2 0 1 0.1";
	colors[1]     = "0.3 0.3 0.3 0.05";
	sizes[0]      = 0.75;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleData(FMFlameExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 5700;
	lifetimeVarianceMS   = 2400;
	textureName          = "base/data/particles/cloud";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -50.0;
	spinRandomMax		 = 50.0;
	colors[0]     = "0.7 0.2 0 1 0.5";
	colors[1]     = "0.2 0.2 0.2 0.2";
	sizes[0]      = 1.00;
	sizes[1]      = 0.15;

	useInvAlpha = true;
};
datablock ExplosionData(FMFlameExplosionEmitter)
{
   ejectionPeriodMS = 35;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 360;
   phiVariance      = 360;
   overrideAdvance = true;
   particles = "FMFlameExplosionParticle";

   useEmitterColors = true;
   uiName = "FM Flame explosion";
};
datablock ParticleEmitterData(FMFlameMuzzleEmitter)
{
   ejectionPeriodMS = 35;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FMFlameMuzzleParticle";

   useEmitterColors = true;
   uiName = "FM Flame muzzle";
};
datablock ProjectileData(FMFlameProjectile)
{
   projectileShapeName = "";
   impactImpulse	     = 4;
   verticalImpulse	  = 4;
   explosion           = FMFlameExplosionEmitter;
   particleEmitter     = "FMFlameMuzzleEmitter";

   muzzleVelocity      = 15;
   velInheritFactor    = 1;

   armingDelay         = 1;
   lifetime            = 777;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "FMFlame Projectile";
};
datablock ItemData(FMFlameGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "Add-Ons/Weapon_Gun/Pistol.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "FM Flame Gun";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "1 0.25 0.25 1.000";
	image = FMFlameGunImage;
	canDrop = true;
};
datablock ShapeBaseImageData(FMFlameGunImage)
{
   shapeFile = "Add-Ons/Weapon_Gun/Pistol.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = FMFlameProjectile;
   projectileType = Projectile;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = FMFlameGunItem.colorShiftColor;
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.01;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]				= "ready";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.03;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitterTime[3]				= 0;
	stateEmitterNode[3]				= "muzzleNode";
	stateEjectShell[3]       		= true;

	stateName[4] 					= "Smoke";
	stateEmitterTime[4]				= 0;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0;
	stateTransitionOnTimeout[4]     = "Ready";
};
function FMFlameProjectile::onCollision(%this,%obj,%col)
{
	if($FMWeaponsEnabled != 1 || $FireModEnabled != 1)
		return;
	if(%col.isPlanted == 1)
	{
		if(%col.isWet==1)
		{
			%col.wetness = %col.wetness - 15;
			if(%col.wetness<=0)
			{
				%col.isWet=0;
				%col.discovered=0;
				FMSet(%col);
			}
		} else
		{
			if(%col.discovered!=1)
			{
				FMSet(%col);
			}
		}
	} else
	{
		if(%col.color!$='' && $FireModDEnabled==1)
		{
			FMBurnZone(%col,5,1);	
		}
	}
}