datablock ParticleData(FMWaterMuzzleParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.5;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.1;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 200.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.3 0.3 0.5 0.1";
	colors[1]     = "0.3 0.3 0.4 0.01";
	sizes[0]      = 0.75;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleData(FMWaterExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 5700;
	lifetimeVarianceMS   = 2400;
	textureName          = "base/data/particles/cloud";
	spinSpeed			 = 10.0;
	spinRandomMin		 = -50.0;
	spinRandomMax		 = 50.0;
	colors[0]     = "0.3 0.3 0.5 0.5";
	colors[1]     = "0.3 0.3 0.4 0.2";
	sizes[0]      = 1.00;
	sizes[1]      = 0.15;

	useInvAlpha = true;
};
datablock ExplosionData(FMWaterExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 360;
   phiVariance      = 360;
   overrideAdvance = true;
   particles = "FMWaterExplosionParticle";

   useEmitterColors = true;
   uiName = "FM water explosion";
};
datablock ParticleEmitterData(FMWaterMuzzleEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FMWaterMuzzleParticle";

   useEmitterColors = true;
   uiName = "FM water muzzle";
};
datablock ProjectileData(FMWaterProjectile)
{
   projectileShapeName = "";
   impactImpulse	     = 4;
   verticalImpulse	  = 4;
   explosion           = FMWaterExplosionEmitter;
   particleEmitter     = "FMWaterMuzzleEmitter";

   muzzleVelocity      = 30;
   velInheritFactor    = 1;

   armingDelay         = 1;
   lifetime            = 2000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.777;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "FMWater Projectile";
};
datablock ItemData(FMWaterGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "Add-Ons/Weapon_Gun/Pistol.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "FM Water Gun";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 1 1.000";
	image = FMWaterGunImage;
	canDrop = true;
};
datablock ShapeBaseImageData(FMWaterGunImage)
{
   shapeFile = "Add-Ons/Weapon_Gun/Pistol.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = FMWaterProjectile;
   projectileType = Projectile;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = FMWaterGunItem.colorShiftColor;
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.01;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]				= "ready";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.03;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitterTime[3]				= 0;
	stateEmitterNode[3]				= "muzzleNode";
	stateEjectShell[3]       		= true;

	stateName[4] 					= "Smoke";
	stateEmitterTime[4]				= 0;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0;
	stateTransitionOnTimeout[4]     = "Ready";
};
function FMWaterProjectile::onCollision(%this,%obj,%col)
{
	if($FMWeaponsEnabled != 1){return;}
	%position = %col.getPosition();
	%radius = 3;
	%mask = $TypeMasks::FxBrickObjectType;
	initContainerRadiusSearch(%position,%radius,%mask);%col = containerSearchNext();
	for (%col =%col;%col != 0;%col = containerSearchNext())
	{
		if(!isObject(%col))
		{
			return;
		}
		if (isObject(%col) && %col.isWet != 1)
		{
			%col.wetness+=20;
			if(%col.charset!=1){%col.charcol = GCPC("0.5 0.5 0.5 1");%col.charset=1;}
		if(isObject(%col) && %col.isWet == 1)
		{
			%col.setColorFX(0);
			%col.setColor(%BID.charcol);
			%col.setEmitter(0);
			cancel(%col.HPSchedNex);
			cancel(%col.SpreadNext);
			cancel(%col.SpreadNextUp);
			cancel(%col.SpreadNextDown);
		}
		if(isObject(%col.getDownBrick(0)) && %col.getDownBrick(0).physing == 1)
		{
			calculateFMPhysics(%col);
			return;
		}
		if(%col.getNumDownBricks() == 0 && %col.getNumUpBricks() == 0 && %col.isBaseplate() != 1)
		{
			calculateFMPhysics(%col);
		}
		}
	}
}